Subject: [PATCH v2 0/8] Introducing per-device MSI domain

From: [email-masked] (Bjorn Helgaas)
Date: Mon, 26 Jan 2015 18:45:06 -0600

On Thu, Jan 08, 2015 at 05:06:04PM +0000, Marc Zyngier wrote:
> MSI-like interrupts are starting to creep out of the PCI world, and
> can now be seen into a number of "platform"-type busses. The MSI
> domain patches recognise that fact, and start providing a way to
> implement this.
> 
> Another problem we have to solve is to identify which MSI domain a
> device is "connected" to. Currently, PCI gets away with a mixture of
> arch-specific callbacks, and a msi_controller structure that can
> optionally carry a pointer to an MSI domain. As we add new bus types
> and start dealing with topologies that do not map to what PCI does,
> this doesn't scale anymore.
> 
> This patch series tries to address some of it by providing a basic
> link between 'struct device' and an MSI domain. It also adds (yet
> another) way for PCI to propagate the domain pointer through the PCI
> device hierarchy, provides a method for OF to kick-start the
> propagation process, and finally allows the PCI/MSI layer to use that
> information. Hopefully this can serve as a model to implement support
> for different but types.
> 
> Additionally, the last three patches use all the above to remove any
> trace of the msi_controller structure from the two GIC interrupt
> controllers we use on arm64, so that they solely rely on the above
> infrastructure. We take this opportunity to also kill the domain
> pointer from the msi_controller structure.
> 
> My hope is to eventually kill msi_controller entirely, and only rely
> on the msi_domain contained in the device structure (any help
> welcomed).
> 
> This has been tested on arm64 with GICv2m (AMD Seattle) and GICv3 ITS
> (FVP model).
> 
> Patches are on top of 3.19-rc3 and available at:
> 
> git://git.kernel.org/pub/scm/linux/kernel/git/maz/arm-platforms.git irq/msi_domain
> 
> As always, comments most welcome.

These generally look fine to me.  I made a couple minor comments (sorry; I
replied to the v1 series, not to this one).  Since most of the recent IRQ
work has gone via you, Thomas, does it make sense for you to do these, too?

Bjorn

> From v1:
> 
> - Allow arch code to set the MSI domain before we try to do so in core
>   code (which is used as a fallback).
> - Allow the MSI domain to be looked-up by using the PHB node.
> - Remove domain field from msi_controller
> 
> [1] https://lkml.org/lkml/2014/12/8/581
> 
> Marc Zyngier (8):
>   device core: Introduce per-device MSI domain pointer
>   PCI/MSI: Add hooks to populate the msi_domain field
>   PCI/MSI: of: Add support for OF-provided msi_domain
>   PCI/MSI: of: Allow msi_domain lookup using the PHB node
>   PCI/MSI: Let pci_msi_get_domain use struct device's msi_domain
>   irqchip: GICv2m: Get rid of struct msi_controller
>   irqchip: gicv3-its: Get rid of struct msi_controller
>   PCI/MSI: Drop domain field from msi_controller
> 
>  drivers/irqchip/irq-gic-v2m.c    | 26 +++++++++-----------------
>  drivers/irqchip/irq-gic-v3-its.c | 33 ++++++++++++++-------------------
>  drivers/pci/msi.c                |  3 +--
>  drivers/pci/of.c                 | 20 ++++++++++++++++++++
>  drivers/pci/probe.c              | 31 +++++++++++++++++++++++++++++++
>  include/linux/device.h           | 20 ++++++++++++++++++++
>  include/linux/msi.h              |  3 ---
>  include/linux/pci.h              |  3 +++
>  8 files changed, 98 insertions(+), 41 deletions(-)
> 
> -- 
> 2.1.4
>